'use strict';
import { getHeroesByFaction } from '../heroesHelper';
export default function selectFactionState(duelController) {
  let duelCtrl = duelController;
  let start = () => {
    let gameData = duelCtrl.getGameData();
    gameData.game.heroes = duelCtrl.getAllHeroes();
    gameData.game['waitingFor/blue'] = true;
    gameData.game['waitingFor/red'] = true;
    gameData.game.currentPlayer = 'both';
    duelCtrl.storeData(gameData);
  };

  let update = (payload = null) => {
    let gameData = duelCtrl.getGameData();
    if (payload) {
      let player = payload.player + 'player';
      gameData[player].faction = payload.faction;
      gameData[player].twelveHeroes = getHeroesByFaction(payload.faction);
      gameData.game['waitingFor/' + payload.player] = false;
      duelCtrl.storeData(gameData);
    }

    if (
      duelCtrl.gameData.game['waitingFor/blue'] === false &&
      duelCtrl.gameData.game['waitingFor/red'] === false
    ) {
      duelCtrl.endCurrentState();
    }
  };

  let end = () => {
    console.log('Go to next game state : 2_CHANGE_UP_TO_3');
  };
  return {
    start,
    update,
    end
  };
}
