'use strict';
function shuffle(a) {
  for (let i = a.length - 1; i > 0; i--) {
    const j = Math.floor(Math.random() * (i + 1));
    [a[i], a[j]] = [a[j], a[i]];
  }
  return a;
}

export const initHeroesFromJson = function(allHeroesJson) {
  let abilitiesMap = new Map();
  allHeroesJson.abilities.forEach(ability => {
    abilitiesMap.set(ability.abilityName, {
      name: ability.abilityName,
      hook: ability.abilityHook,
      isOptionnal: ability.optionnal,
      desc: ability['abilityDesc-FR']
    });
  });
  let heroes = [];
  let heroUniqueId = 0;
  allHeroesJson.heroes.forEach(hero => {
    let i = 0;
    while (i < hero.nbInDeck) {
      heroes.push({
        id: heroUniqueId,
        name: hero.name,
        cost: hero.cost,
        power: hero.power,
        faction: hero.faction,
        ability: abilitiesMap.get(hero.ability),
        isDraftable: hero.draftMode,
        popularity: hero.popularity
      });
      heroUniqueId++;
      i++;
    }
  });
  return heroes;
};
export const getHeroesByFaction = function(allHeroes, faction) {
  return allHeroes.filter(hero => {
    return hero.faction === faction;
  });
};
export const getDraftSets = function(allHeroes) {
  let heroesDraftable = allHeroes.filter(hero => {
    return hero.isDraftable === true;
  });

  let shuffledHeroes = shuffle(heroesDraftable);

  // Return 4 sets of 6 heroes for draft mode
  let draftSets = [
    shuffledHeroes.slice(0, 5),
    shuffledHeroes.slice(6, 11),
    shuffledHeroes.slice(12, 17),
    shuffledHeroes.slice(18, 23)
  ];
  return draftSets;
};
export const shuffleHeroes = function(heroes) {
  return shuffle(heroes);
};
